dojo.hostenv.packageLoaded({
depends: [["require", "dojo.widget.Menu"],
["provide", "dojo.widget.html.Menu"]],
definePackage: function(dojo){/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

dojo.require("dojo.widget.Menu");
dojo.provide("dojo.widget.html.Menu");

/* HtmlMenu
 ***********/
 
dojo.widget.html.Menu = function(){
	dojo.widget.html.Menu.superclass.constructor.call(this);
	this.items = [];
}
dojo.inherits(dojo.widget.html.Menu, dojo.widget.HtmlWidget);

dojo.lang.extend(dojo.widget.html.Menu, {
	widgetType: "Menu",
	isContainer: true,

	// copy children widgets output directly to parent (this node), to avoid
	// errors trying to insert an <li> under a <div>
	snarfChildDomOutput: true,

	templateString: '<ul></ul>',
	templateCssString:".dojoMenu {\n	border:1px solid #000000;\n	list-style-type:none;\n	margin:0;\n	padding:0;\n	padding-bottom: 1px;\n	background-color:#f4f4f4;\n	font-size: 8pt;\n}\n\n.dojoMenuSeparator {\n	list-style-type:none;\n	margin:0;\n	padding:1px 0;\n	border-bottom:1px solid #000000;\n	line-height:1px;\n	height:1px;\n}\n\nli:hover.dojoMenuSeparator {\n	background-color:#e5e5e5;\n	cursor:default;\n}\n\n\n\n\n.dojoContextMenu {\n	position: absolute;\n	display: none;\n	border: 2px solid;\n	border-color: ThreeDHighlight ThreeDShadow ThreeDShadow ThreeDHighlight;\n	list-style-type: none;\n	margin: 0;\n	padding: 1px;\n	background-color: ThreeDFace;\n	font-size: 8pt;\n}\n\n.dojoMenuItem {\n	white-space: nowrap;\n	padding: 2px;\n	font: menu;\n	color: WindowText;\n}\n\n.dojoMenuItem a {\n	text-decoration: none;\n	color: WindowText;\n	font: inherit;\n}\n\n.dojoMenuItemHover {\n	padding: 2px;\n	background-color: blue;\n	cursor: pointer;\n	_cursor: hand;\n	background-color: Highlight;\n	color: HighlightText;\n}",templateCssPath:dojo.uri.dojoUri("src/widget/templates/Menu.css"),
	
	fillInTemplate: function (args, frag){
		//dojo.widget.HtmlMenu.superclass.fillInTemplate.apply(this, arguments);
		this.domNode.className = "dojoMenu";
	},
	
 
	_register: function (item ) {
		dojo.event.connect(item, "onSelect", this, "onSelect");
		this.items.push(item);
	},

	push: function (item) {
		this.domNode.appendChild(item.domNode);
		this._register(item);
	}

});


}});