dojo.hostenv.packageLoaded({
depends: [["provide", "dojo.widget.html.Show"],
["require", "dojo.widget.*"],
["require", "dojo.widget.HtmlWidget"],
["require", "dojo.widget.Show"],
["require", "dojo.uri.Uri"],
["require", "dojo.event"],
["require", "dojo.animation.Animation"],
["require", "dojo.math.curves"],
["require", "dojo.html"],
["require", "dojo.lang.common"],
["require", "dojo.lang.func"]],
definePackage: function(dojo){/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

dojo.provide("dojo.widget.html.Show");

dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.Show");
dojo.require("dojo.uri.Uri");
dojo.require("dojo.event");
dojo.require("dojo.animation.Animation");
dojo.require("dojo.math.curves");
dojo.require("dojo.html");
dojo.require("dojo.lang.common");
dojo.require("dojo.lang.func");

dojo.widget.defineWidget(
	"dojo.widget.html.Show",
	dojo.widget.HtmlWidget,
	null,
	"html",
	function(){
		dojo.widget.Show.call(this);
	}
);
dojo.lang.extend(dojo.widget.html.Show, dojo.widget.Show.prototype);
dojo.lang.extend(dojo.widget.html.Show, {
	body: null,
	nav: null,
	hider: null,
	select: null,
	option: null,
	inNav: false,
	templateString:"<div class=\"dojoShow\">\n	<div dojoAttachPoint=\"contentNode\"></div>\n	<div class=\"dojoShowNav\" dojoAttachPoint=\"nav\">\n		<div class=\"dojoShowHider\" dojoAttachPoint=\"hider\"></div>\n		<span dojoAttachEvent=\"onClick:previousSlide\">&lt;</span>\n		<select dojoAttachEvent=\"onClick:gotoSlideByEvent\" dojoAttachPoint=\"select\">\n			<option dojoAttachPoint=\"option\">Title</option>\n		</select>\n		<span dojoAttachEvent=\"onClick:nextSlide\">&gt;</span>\n	</div>\n</div>",
	templateCssString:"@media screen {\n	html, body {\n		margin: 0px;\n		padding: 0px;\n		width: 100%;\n	}\n	body {\n		display: none;\n	}\n	h1 {\n		font-size: 50px;\n	}\n	p, li {\n		font-size: 30px;\n	}\n	.dojoShowNav {\n		background: #369;\n		overflow: hidden;\n		position: absolute;\n		height: 5px;\n		bottom: 0px;\n		left: 0px;\n		width: 100%;\n		text-align: center;\n	}\n	.dojoShowNav input {\n		margin: 0px;\n	}\n	.dojoShowHider {\n		height: 5px;\n		overflow: hidden;\n		width: 100%;\n	}\n	.dojoShowPrint {\n		position: absolute;\n		left: 5px;\n		top: 0px;\n	}\n}\n@media print {\n	.dojoShow {\n		display: none !important;\n	}\n	.dojoShowPrint {\n		display: block !important;\n	}\n	.dojoShowPrintSlide {\n		border: 1px solid #aaa;\n		padding: 10px;\n		margin-bottom: 15px;\n	}\n	.dojoShowPrintSlide, ul {\n	page-break-inside: avoid;\n	}\n	h1 {\n		margin-top: 0;\n		page-break-after: avoid;\n	}\n}",templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlShow.css"),
	fillInTemplate: function(args, frag){
		var source = this.getFragNodeRef(frag);
		this.sourceNode = document.body.appendChild(source.cloneNode(true));
		for(var i = 0, child; child = this.sourceNode.childNodes[i]; i++){
			if(child.tagName && child.getAttribute("dojotype").toLowerCase() == "showslide"){
				child.className = "dojoShowPrintSlide";
				child.innerHTML = "<h1>" + child.title + "</h1>" + child.innerHTML;
			}
		}
		this.sourceNode.className = "dojoShowPrint";
		this.sourceNode.style.display = "none";
		
		dojo.event.connect(document, "onclick", this, "gotoSlideByEvent");
		dojo.event.connect(document, "onkeypress", this, "gotoSlideByEvent");
		dojo.event.connect(window, "onresize", this, "resizeWindow");
		dojo.event.connect(this.nav, "onmousemove", this, "popUpNav");
	},
	postCreate: function(){		
		this._slides = [];
		for(var i = 0, child; child = this.children[i]; i++){
			if(child.widgetType == "ShowSlide"){
				this._slides.push(child);
				this.option.text = child.title;
				this.option.parentNode.insertBefore(this.option.cloneNode(true), this.option);
			}
		}
		this.option.parentNode.removeChild(this.option);

		document.body.style.display = "block";
		this.resizeWindow();
		this.gotoSlide(0);
	},
	gotoSlide: function(/*int*/ slide){
		if(slide == this._slide){
			return;
		}

		if(!this._slides[slide]){
			// slide: string
			for(var i = 0, child; child = this._slides[i]; i++){
				if(child.title == slide){
					slide = i;
					break;
				}
			}
		}
		
		if(!this._slides[slide]){
			return;
		}
		
		if(this._slide != -1){
			while(this._slides[this._slide].previousAction()){}
		}
		
		this._slide = slide;
		this.select.selectedIndex = slide;
		while(this.contentNode.hasChildNodes()){ this.contentNode.removeChild(this.contentNode.firstChild); }
		this.contentNode.appendChild(this._slides[slide].domNode);
	},
	gotoSlideByEvent: function(/*Event*/ event){
		var node = event.target;
		var type = event.type;
		if(type == "click"){
			if(node.tagName == "OPTION"){
				this.gotoSlide(node.index);
			}else if(node.tagName == "SELECT"){
				this.gotoSlide(node.selectedIndex);
			}else if(node.tagName != "A"){
				this.nextSlide(event);
			}
		}else if(type == "keypress"){
			var key = event.keyCode;
			var ch = event.charCode;
			if(key == 63234 || key == 37){
				this.previousSlide(event);
			}else if(key == 63235 || key == 39 || ch == 32){
				this.nextSlide(event);
			}
		}
	},
	nextSlide: function(/*Event?*/ event){
		this.stopEvent(event);
		return dojo.widget.Show.prototype.nextSlide.call(this, event);
	},
	previousSlide: function(/*Event?*/ event){
		this.stopEvent(event);
		return dojo.widget.Show.prototype.previousSlide.call(this, event);
	},
	stopEvent: function(/*Event*/ ev){
		if(window.event){
			ev.returnValue = false;
			ev.cancelBubble = true;
		}else{
			ev.preventDefault();
			ev.stopPropagation();
		}
	},
	popUpNav: function(){
		if(!this.inNav){
			dojo.widget.Show.node = this.nav;
			var anim = new dojo.animation.Animation(new dojo.math.curves.Line([5], [30]), 250, -1);
			dojo.event.connect(anim, "onAnimate", function(e) {
				dojo.widget.Show.node.style.height = e.x + "px";
			});
			dojo.event.connect(anim, "onEnd", function(e) {
				dojo.widget.Show.node.style.height = e.x + "px";
			});
			anim.play(true);
		}
		clearTimeout(this.inNav);
		this.inNav = setTimeout(dojo.lang.hitch(this, "hideNav"), 2000);
	},
	hideNav: function(){
		clearTimeout(this.inNav);
		this.inNav = false;

		dojo.widget.Show.node = this.nav;
		var anim = new dojo.animation.Animation(new dojo.math.curves.Line([30], [5]), 250, 1);
		dojo.event.connect(anim, "onAnimate", function(e) {
			dojo.widget.Show.node.style.height = e.x + "px";
		});
		dojo.event.connect(anim, "onEnd", function(e) {
			dojo.widget.Show.node.style.height = e.x + "px";
		});
		anim.play(true);
	},
	resizeWindow: function(/*Event*/ ev){
		document.body.style.height = "auto";
		var h = Math.max(
			document.documentElement.scrollHeight || document.body.scrollHeight,
			dojo.html.getViewportHeight());
		document.body.style.height = h + "px";
	}
});
}});